﻿/*  
     This file is part of Emulators Organizer
    A program that organize emulators and roms.
   
    Copyright (C) 2009 - 2012  Ali Hadid, programmed by Ala Hadid

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AHD.Emulators_Organizer.Base
{
    public struct DatabaseRom
    {
        public DatabaseRom(string name, string description, string path, string sha1, string crc, string md5)
        {
            this.name = name;
            this.description = description;
            this.sha1 = sha1;
            this.crc = crc;
            this.md5 = md5;
            this.path = path;
        }
        string name;
        string description;
        string sha1;
        string crc;
        string md5;
        string path;
        /// <summary>
        /// Get or set the Name of this rom
        /// </summary>
        public string Name
        { get { return name; } set { name = value; } }
        /// <summary>
        /// Get or set the Description of this rom
        /// </summary>
        public string Description
        { get { return description; } set { description = value; } }
        /// <summary>
        /// Get or set the SHA1 of this rom
        /// </summary>
        public string SHA1
        { get { return sha1; } set { sha1 = value; } }
        /// <summary>
        /// Get or set the SHA1 of this rom
        /// </summary>
        public string CRC
        { get { return crc; } set { crc = value; } }
        /// <summary>
        /// Get or set the SHA1 of this rom
        /// </summary>
        public string MD5
        { get { return md5; } set { md5 = value; } }
        /// <summary>
        /// Get or set the path of rom, this used only for save
        /// </summary>
        public string Path
        { get { return path; } set { path = value; } }
        public static DatabaseRom Empty = new DatabaseRom("", "", "", "", "", "");
    }
}
