﻿/*  
     This file is part of Emulators Organizer
    A program that organize emulators and roms.
   
    Copyright (C) 2009 - 2012  Ali Hadid, programmed by Ala Hadid

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
namespace AHD.Emulators_Organizer.Base
{
    [Serializable()]
    public class EmuConsole
    {
        string _Name = "";
        string _InfoFolder = "";
        string _HistoryFolder = "";
        string _downloadsFolder = "";
        bool _coppyRomToDownloadsFolder = true;
        Image _Icon;
        List<Rom> _Roms = new List<Rom>();
        List<Emulator> _Emulators = new List<Emulator>();
        List<Category> _Categories = new List<Category>();
        List<string> _Extensions = new List<string>();
        List<string> _ImageDirs = new List<string>();
        List<string> _CoverDirs = new List<string>();
        List<string> _PDFDirs = new List<string>();
        List<string> _VideoDirs = new List<string>();
        List<string> _VideoExtensions = new List<string>();
        List<string> _SoundDirs = new List<string>();
        List<string> _SoundExtensions = new List<string>();
        List<string> _Folders = new List<string>();

        public string DownloadsFolder
        { get { return _downloadsFolder; } set { _downloadsFolder = value; } }
        public bool CopyRomToDownloadsFolder
        { get { return _coppyRomToDownloadsFolder; } set { _coppyRomToDownloadsFolder = value; } }
        public string InfoFolder
        { get { return _InfoFolder; } set { _InfoFolder = value; } }
        public string HistoryFolder
        { get { return _HistoryFolder; } set { _HistoryFolder = value; } }
        public List<Rom> Roms
        { get { return _Roms; } }
        public List<Emulator> Emulators
        { get { return _Emulators; } }
        public List<Category> Categories
        { get { return _Categories; } }
        public List<string> Extensions
        { get { return _Extensions; } set { _Extensions = value; } }
        public List<string> ImageDirs
        { get { return _ImageDirs; } set { _ImageDirs = value; } }
        public List<string> CoverDirs
        { get { return _CoverDirs; } set { _CoverDirs = value; } }
        public List<string> PDFDirs
        { get { return _PDFDirs; } set { _PDFDirs = value; } }
        public List<string> Folders
        { get { return _Folders; } set { _Folders = value; } }
        public List<string> VideoDirs
        { get { return _VideoDirs; } set { _VideoDirs = value; } }
        public List<string> VideoExtensions
        { get { return _VideoExtensions; } set { _VideoExtensions = value; } }

        public List<string> SoundDirs
        { get { return _SoundDirs; } set { _SoundDirs = value; } }
        public List<string> SoundExtensions
        { get { return _SoundExtensions; } set { _SoundExtensions = value; } }

        public string Name
        { get { return _Name; } set { _Name = value; } }
        public Image Icon
        { get { return _Icon; } set { _Icon = value; } }
    }
}
