﻿/*  
     This file is part of Emulators Organizer
    A program that organize emulators and roms.
   
    Copyright (C) 2009 - 2012  Ali Hadid, programmed by Ala Hadid

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
namespace ISO9660.Enums
{

    internal enum Endian
    {
        LittleEndian,
        BigEndian
    };
    /// <summary>
    /// Describes the volume descriptor type; the numbers are set according to the ISO 9660 standard.
    /// </summary>
    internal enum VolumeType
    {
        BootRecord = 0,		// Number 0: shall mean that the Volume Descriptor is a Boot Record 
        // (never used in this program... maybe in future distributions).

        Primary = 1,			// Number 1: shall mean that the Volume Descriptor is a Primary Volume Descriptor

        Suplementary = 2,		// Number 2: shall mean that the Volume Descriptor is a Supplementary Volume Descriptor

        Partition = 3,		// Number 3: shall mean that the Volume Descriptor is a Volume Partition Descriptor

        SetTerminator = 255	// Number 255: shall mean that the Volume Descriptor is a Volume Descriptor Set Terminator.
    };
}